[bits 16]
[org 0x7c00]
;	### Set Env

	mov sp, 0x7C00 ; stack = 0x7c00
	
	;fs = vmem
	mov ax, 0xb800 ;0xb8000 / 0x10 
	mov fs, ax
	; ds - local use
	; gs - always 0
	xor ax, ax
	mov gs, ax
	
	
	; clear screen / set text mode
	mov al, 0x3
	int 0x10
	
	
	; disabled cursor
	mov ch, 10000b
	mov ah, 1
	int 10h 
	;jmp $
;	### Main

start:
	; env
		;xor cx, cx ; i = 0
	; render loop
	render: ; 80x25
		xor cx, cx ; i = 0
	bg:
		
		; get x, y
		mov ax, cx 
		mov bx, 80
		xor dx, dx ; clear dx
		div bx ; dx = modulo (x) ax = y
		
		; # sin
		mov bx, sin
		shr bx, 4 ; ptr sin / 16
		mov ds, bx ;ds to sin
		;push ax ; ax always == y
		add ax, word [gs:fcount]
		
		; sin - % 21
		mov bx, 20 ; % 21
		call modulo
		
		xor ax, ax
		mov al, byte [ds:bx] ; sin to ax
		cbw
		add dx, ax
		;pop ax
		
		
		; line % 6 (color)
		mov ax, dx
		mov bx, 6
		xor dx, dx
		div bx; dx = modulo ax = div
		
		
		; to line
		xor ax, ax
		inc dx
		mov ah, dl
		shl ah, 4
		or ax, 178 ; 8 - ok
		mov dx, ax
		
		; put pixel
		mov bx, cx
		add bx, bx ; bx *= 2
		mov[fs:bx], word dx
	; for
	inc cx ; i++
	cmp cx, 2000 ; i == 2000 
	jnz bg ; loop; end bg render
	
	; Text loop:
	
	xor cx, cx ; i = 0
	tl:
		
		; ds to text
		mov bx, text
		shr bx, 4
		mov ds, bx
		
		; get char
		mov bx, cx 
		mov al, [ds:bx] ;al = text:cx
		push ax; char to stack
		
		;(12+sin)*80
		mov bx, sinText ; ds to sin
		shr bx, 4
		mov ds, bx
		
		
		mov ax, cx ; ax to x
		sub ax, [gs:f4count]; sub x time offset
		mov bx, 40 ; modulo 40 <len(sin)>
		call modulo ; bx = modulo
		
		xor ax, ax
		mov al, byte [ds:bx] ; al to sin
		cbw ; byte to word

		add ax, 17 ; pos y
		
		mov bx, ax
		mov ax, 80; max screen x
		mul bx ; y*80
		mov bx, ax
		;mov bx, 960 ; center
		
		push bx
		
		; vmem offset
		add ax, cx ; add text x
		sub ax, [gs:f4count]; sub x time offset
		mov bx, 80
		call modulo ; modulo text 80
		mov ax, bx
		pop bx
		add bx, ax ; add text x offset to vmem offset
		
		;get saved char
		pop ax; stack to char
		
		;font mod
		or ax, 1000000000000000b
		
		
		
		;put
		add bx, bx; bx*2
		mov [fs:bx], ax
		
		
	inc cx ; i++
	cmp cx, 56 ; i  == len(text)
	jnz tl ; loop; end text render
	
	
	; big sin loop
	xor cx, cx ; i = 0
	bs:
		mov bx, sin ; ds to sin
		shr bx, 4
		mov ds, bx
		
		mov ax, cx ; ax to sin len actual x
		add ax, [gs:fcount]; sub x time offset
		mov bx, 20 ; modulo 40 <len(sin)>
		call modulo ; bx = modulo
		
		
		xor ax, ax
		mov al, byte [ds:bx] ; al to sin
		;cbw ; byte to word

		add ax, 3 ; pos y
		
		mov bx, ax
		mov ax, 80; max screen x
		imul bx ; y*80
		mov bx, ax
		
		push bx
		
		; vmem offset
		add ax, cx ; add sin len
		
		;call subFcount; sub x time offset
		add ax, [gs:fcount]; sub x time offset 
		mov bx, 80
		call modulo ; modulo sin 80
		mov ax, bx
		
		pop bx
		add bx, ax ; add text x offset to vmem offset
		
		;font mod
		mov ah, [gs:bigsincolor] ; get color
		and ah, 0111b ; no blink
		shl ah, 4
		or ah, [gs:bigsincolor] ; white
		xor ah, 1111b
		mov al, 175; in 'snake' char 
		
		;put
		add bx, bx; bx*2
		mov [fs:bx], ax
		
	inc cx ; i++
	cmp cx, [gs:bigsinlen];40 ; i  == len(sin)
	jnz bs ; loop; end sin render
	
	
	; wait
	mov cx, 1
	mov dx, 1130 ; 15fps = 66666
	mov ah, 0x86
	int 0x15
	
	; next time counters

	inc word [gs:fcount] ; frame time
	
	mov ax, word [gs:fcount] ; freme time / 4
	
	shr ax, 2	
	mov [gs:f4count], ax

	mov ax, word [gs:fcount] ; next color
	mov bx, 80
	call modulo
	test bx, bx
	jnz render ; end render frame
	inc byte [gs:bigsincolor]
	add byte [gs:bigsinlen], 4 ; add 4 to len
	cmp byte [gs:bigsinlen], 84 ; if full size
	jnz render
	mov byte [gs:bigsinlen], 20
	jmp render ; end render frame
	

	
;	### Function

modulo: ;  modulo(ax%bx) bx = modulo
	push dx
	xor dx, dx
	div bx
	mov bx, dx
	pop dx
	ret

		
;	### Global var
fcount dw 0
f4count dw 0
bigsincolor: db 1
bigsinlen: db 20

;	### Data
times (16 - ($ - $$) % 16) db 0 ; padding data
sin: db 5, 7, 8, 9, 9, 10, 9, 9, 8, 7, 5, 3, 2, 1, 1, 0, 1, 1, 2, 3, 6

times (16 - ($ - $$) % 16) db 0 ; padding data
sinText: db 2, 2, 3, 3, 3, 3, 4, 4, 4, 4, 4, 4, 4, 4, 4, 3, 3, 3, 3, 2, 2, 2, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 2, 2
times (16 - ($ - $$) % 16) db 0 ; padding data
text: db 'SinSinSin!',3,3,3,'512B',251,'Extra char!(',127,209,127,')','Like a demo',3,247,2,247,'byM648'


;	### Padding
times 510-($-$$) db 0
db 0x55
db 0xAA

;times 1474560-($-$$) db 0 ; floppy size
