[bits 16]
[org 0x7c00]
; 0x7c00
; SEGMENT:OFFSET
; adres = SEGMENT * 0x10 + OFFSET
; CS 07c0  0000
; IP 0000  7c00
;          ****

jmp word 0x0000:start

start:
  ; Load from floppy stage 2.
  ; DL == already set by BIOS
  ; AX -- 16 bits, AH AL -- 8 bits
  ; EAX -- AX
  
	; clear screen
	mov ax,0003h
  int 10h 
	
	; modify font
	; VIDEO - TEXT-MODE CHARGEN - LOAD USER-SPECIFIED PATTERNS (PS,EGA,VGA)

  ; AX = 1110h
  ; ES:BP -> user table
  ; CX = count of patterns to store
  ; DX = character offset into map 2 block
  ; BL = block to load in map 2
  ; BH = number of bytes per character pattern
	mov ax, 1110h
	mov bx, 0
	mov es, bx
	lea bp, [font]
	mov cx, SWAPPEDCHARSCOUNT
	mov dx, SWAPPEDCHAR
	mov bl, 00
	mov bh, 0x10
	int 10h
	
	; CX - loop counter
	xor cx, cx
	mov cx, TERMWIDTH
draw:
drawLine:
	; backup #1
	mov si, cx ; si - remainder of lines to write
	; source: http://wiki.osdev.org/Real_mode_assembly_III#Timing:_Fun_in_a_Few_Interrupts
	; return CX:DX ticks since midnight
	xor ax, ax
  int 1Ah
	mov ax, dx
	mov bx, TERMWIDTH
	sub bx, si
	push bx
	mov bx, 0
	mov ds, bx
	pop bx
	push ax
	push bx
	; ax - timer 
	; bx - iteration
	mov ax, bx
	mov bx, LIMIT
	xor dx, dx
	div bx
	mov bx, dx
	pop dx ; discard value
	pop ax
	add al, BYTE [pattern + bx]
	xor dx, dx
	mov bx, LIMIT
	div ebx
	cmp dx, 0
	jne .next
	mov dx, 1
.next:
	mov di, dx ; di - how much chars code should write
	mov cx, di
	drawChar:
		rdtsc ; load to EDX:EAX
		call linearRand
		mov ebx, CHARDIFF
		xor edx, edx
		div ebx ; div value in EDX:EAX, returns remainder in EDX
		mov ax, dx
		add ax, FIRSTCHAR	; set drawn to range 33 - 126 (ascii code - readable char)
		; backup #3
		mov bp, ax ; bp - char to draw
		mov bx, LINEWIDTH
		mov ax, di
		sub ax, cx
		mul bx ; return value in DX:AX - our result should be always only in AX
		mov bx, TERMWIDTH
		sub bx, si
		add ax, bx ; width offset
		shl ax, 1 ; one char in VGA resident in 2 bytes
		mov bx, VGAADDR
		mov ds, bx
		mov bx, ax
		
		mov BYTE [ds:bx + 1], FGCOLOR ; and colors!
		mov ax, bp
		mov [ds:bx], al ; put char in appriopriate address...
		LOOP drawChar
end:
	mov cx, si
	LOOP drawLine
	
	; df?
	; print OS name
	xor bx, bx
	mov ds, bx
	mov bx, osname
	mov si, bx
	
	mov bx, OSNAMESEG
	mov es, bx
	mov bx, OSNAMEPOS
	mov di, bx
	mov cx, OSNAMELENGTH
	rep movsb
	
	; draw logo, todo - loop should be shorter than this monster and fix 1px gaps between characters
	mov bx, LOGOSEG
	mov ds, bx
	mov bx, LOGOPOS
	
	mov BYTE [ds:0 + bx], SWAPPEDCHAR
	mov BYTE [ds:0 + 1 + bx], LOGOCOLOR	
	mov BYTE [ds:0 + 2 + bx], SWAPPEDCHAR + 2
	mov BYTE [ds:0 + 3 + bx], LOGOCOLOR		
	mov BYTE [ds:0 + 4 + bx], SWAPPEDCHAR + 4
	mov BYTE [ds:0 + 5 + bx], LOGOCOLOR		
	mov BYTE [ds:0 + 6 + bx], SWAPPEDCHAR + 6
	mov BYTE [ds:0 + 7 + bx], LOGOCOLOR
	
	mov bx, LOGOSEG + 0x0a
	mov ds, bx
	mov bx, LOGOPOS
	
	mov BYTE [ds:0 + bx], SWAPPEDCHAR + 1
	mov BYTE [ds:0 + 1 + bx], LOGOCOLOR	
	mov BYTE [ds:0 + 2 + bx], SWAPPEDCHAR + 3
	mov BYTE [ds:0 + 3 + bx], LOGOCOLOR		
	mov BYTE [ds:0 + 4 + bx], SWAPPEDCHAR + 5
	mov BYTE [ds:0 + 5 + bx], LOGOCOLOR		
	mov BYTE [ds:0 + 6 + bx], SWAPPEDCHAR + 7
	mov BYTE [ds:0 + 7 + bx], LOGOCOLOR		
	
	; copy data from TESTMSG address to graphics memory (VGAADDR)
	;mov ax, VGAADDR
	;mov es, ax
	;mov di, 0 ; ...to es:di [0xb00:0] = 0xb000
	;lea ax, [TESTMSG]
	;shr ax, 4
	;mov ds, ax
	;mov si, 0 ; from ds:si...
	;mov cx, DATASIZE
	;cld		; DF = 0 - increment SI and DI
	;rep movsb
	
  mov ax, 0x2000 ; 0x2000:0x0000
  mov es, ax
  xor bx, bx ; bx == 0

  mov ah, 2  ; read sectors into memory
  mov al, 0xcc  ; 1337 stage2  3 * 512 
  nop
  nop
  mov ch, 0
  mov cl, 2  ; sectors start from 1, or so they say ;)
  mov dh, 0

  int 13h
  
  ; Jump to stage 2
  jmp word 0x2000:0x0000

  ; The CPU doesn't reach here. Ever. Hopefully.

linearRand:
	; seed in eax, return - eax
	push bx
	mov ebx, 1103515245
	mul ebx
	add eax, 12345
	pop bx
	ret
	
; some constant which helps in understading my shitty code
VGAADDR equ 0x0b800 ; segment version of text mode graphics addr (0xb8000 / 10 )
TERMHEIGHT equ 24
TERMWIDTH equ 79
; VGA buffer = 4000 bytes (width * height * 2)
; One line difference in VGA - 80 * 2 = 160 bytes
LINEWIDTH equ 80

DATASIZE equ 256
FIRSTCHAR equ 0x40 ; '@'
CHARDIFF equ 63 ; subtraction of last readable char ascii code from first
LIMIT equ 16
LOGOSEG equ 0x0b8ef
LOGOPOS equ 0x00006 ; LOGOSEG:LOGOPOS - logo position
OSNAMESEG equ 0x0b8ed
OSNAMEPOS equ 0x00006
SWAPPEDCHAR equ 0x28 ; '('
SWAPPEDCHARSCOUNT equ 8
; Format of chars in graphics memory:
; BGBGFGFG
; or bBBBIFFF, where: 
; b - blink
; B - background color  
; I - foreground intensity
; F - foreground color
; source: https://en.wikipedia.org/wiki/VGA-compatible_text_mode#Text_buffer
FGCOLOR equ 00000010b ; sweet matrix-like green text
LOGOCOLOR equ 00001001b ; soothing ultramarine

pattern: 	db 15, 14, 11, 10, 5, 7, 6, 9 
					db 8, 10, 12, 13, 11, 7, 6, 4, 5, 9, 8, 10, 6, 4, 3, 2
	; Gynvael's OSDEV
osname: db 0x47, LOGOCOLOR
				db 0x79, LOGOCOLOR
				db 0x6e, LOGOCOLOR
				db 0x76, LOGOCOLOR
				db 0x61, LOGOCOLOR 
				db 0x65, LOGOCOLOR
				db 0x6c, LOGOCOLOR
				db 0x27, LOGOCOLOR
				db 0x73, LOGOCOLOR
				db 0x20, LOGOCOLOR
				db 0x4f, LOGOCOLOR
				db 0x53, LOGOCOLOR
				db 0x44, LOGOCOLOR
				db 0x45, LOGOCOLOR
				db 0x56, LOGOCOLOR
OSNAMELENGTH equ $-osname
font:;(0, 0)
	db 00000001b
	db 01111111b
	db 11000000b
	db 01111000b
	db 00001111b
	db 00000001b
	db 00000011b
	db 00000110b
	db 00000100b
	db 00001101b
	db 00011000b
	db 00010000b
	db 00110000b
	db 01100000b
	db 01000110b
	db 11001110b
	;(0, 1)
	db 10001100b
	db 11111000b
	db 00001111b
	db 00000001b
	db 00000000b
	db 00000000b
	db 00000000b
	db 00000000b
	db 00000000b
	db 00000000b
	db 00000000b
	db 00000000b
	db 00000000b
	db 00000000b
	db 00000000b
	db 00000000b
	;(1, 0)
	db 11111111b
	db 00010000b
	db 00010000b
	db 00110000b
	db 01100000b
	db 01100000b
	db 00111000b
	db 00001110b
	
	db 00000000b
	db 11110000b
	db 11111000b
	db 00111100b
	db 01100000b
	db 01000000b
	db 00000011b
	db 00110001b
	;(1, 1)
	db 00010001b
	db 00011010b
	db 00000110b
	db 11000100b
	db 01100100b
	db 00110000b
	db 00011100b
	db 00000111b
	
	db 00000000b
	db 00000000b
	db 00000000b
	db 00000000b
	db 00000000b
	db 00000000b
	db 00000000b
	db 00000000b
	;(2, 0)
	db 11111111b
	db 00001000b
	db 00001000b
	db 00001100b
	db 00000110b
	db 00000110b
	db 00011100b
	db 01110000b
	
	db 00000000b
	db 00001111b
	db 00011111b
	db 00111111b
	db 00011100b
	db 00000110b
	db 11000110b
	db 10000000b
	;(2, 1)
	db 10000000b
	db 01011000b
	db 01110000b
	db 00000011b
	db 00000110b
	db 00001100b
	db 00111000b
	db 11100000b
	
	db 00000000b
	db 00000000b
	db 00000000b
	db 00000000b
	db 00000000b
	db 00000000b
	db 00000000b
	db 00000000b
	;(3, 0)
	db 10000000b
	db 11111110b
	db 00000011b
	db 00011110b
	db 11110000b
	db 10000000b
	db 11000000b
	db 01100000b
	
	db 00100000b
	db 00110000b
	db 00011000b
	db 00001000b
	db 00001100b
	db 00000110b
	db 01100010b
	db 01110011b
	
	;(3, 1)
	db 00110001b
	db 00011111b
	db 11110000b
	db 10000000b
	db 00000000b
	db 00000000b
	db 00000000b
	db 00000000b
	
	db 00000000b
	db 00000000b
	db 00000000b
	db 00000000b
	db 00000000b
	db 00000000b
	db 00000000b
	db 00000000b
	
epilogue:
%if ($ - $$) > 510
  %fatal "Bootloader code exceed 512 bytes."
%endif

times 510 - ($ - $$) db 0
db 0x55
db 0xAA



