;----------------------------------------------------------
; Title  : "Stage of the Art" (compo version)
; Date   : 12.06.2016
; Version: 0.7
; Author : Mariusz Bartosik (Lazarus/Nah-Kolor)
; Contact: info@mariuszbartosik.pl
; Desc   : 512b intro for Gynvael's OSDev #4 competition
;          (http://gynvael.coldwind.pl/?id=609).
;          Looks like my first text-mode 512b intro (277b currently).
;          The code is highly unoptimized (read: crappy ;) because it seems
;          I forgot most of the x86 asm. I prefer Motorola 680x0 asm anyway :).
;          Tested under Bochs 2.6.8. Somehow it takes a long time to
;          emulate is smoothly. Also, VGA update frequency should be set to
;          at least 15 fps (already changed in included osdev.bochsrc).
; TODO:
; - use a timer instead of cpu-dependent variable increments
; - use registers instead of memory
; - custom palette and shading
; - double buffering?
;----------------------------------------------------------
[bits 16]
[org 0x7c00]

jmp word 0x0000:start
start:
 mov ax, 0xb800
 mov fs, ax
 mov word [time], 0
 fninit
render:
 mov word [posy], 0
loop_y:
 mov word [posx], 0
loop_x:
 fild word [time]
 fmul dword [timefactor]
 fsincos                  ; st0 cos(st0), st1 sin(st0)
 fmul dword [ampx]        ; st0 = st0 * ampx
 fadd dword [centerx]     ; st0 = st0 + centerx
 fstp dword [calccx]      ; st0 = st1
 fmul dword [ampy]        ; st0 = st0 * ampy
 fadd dword [centery]
 fstp dword [calccy]

 fild word [posx]       ; st0 = posx
 fsub dword [calccx]    ; st0 = posx - calccx
 fdiv dword [normx]     ; st0 = (posx - calcxx) / normx
 fmul st0, st0          ; x2 * x2

 fild word [posy]
 fsub dword [calccy]
 fdiv dword [normy]
 fmul st0, st0          ; y2 * y2

 fadd st0, st1
 fsqrt                  ; st0 = d
 ffree st1
 fmul dword [scaled]
 fild word [time]
 fmul dword [scalet]

 fsubr st0, st1         ; s0 - t, s1 - d
 ffree st1
 fcos
 fld1
 fadd st0, st1
 ffree st1
 fmul dword [scalet]    ; reused
 fmul dword [gradients]
 fistp word [result]
 mov dx, [result]       ; done
;----
 mov bx, word [posy]
 mov al, 80
 mul bl                 ; al * bl -> ah:al
 mov bx, word [posx]
 add ax, bx
 shl ax, 1              ; (posy * 80 + posx ) * 2
 mov bx, ax

 mov si, gradient
 add si, dx
 mov al, [si]           ; character
 mov ah, 0x9            ; attibute
 mov [fs:bx], ax

 inc word [posx]
 mov ax, word [posx]
 cmp ax, 80
 jne loop_x

 inc word [posy]
 mov ax, word [posy]
 cmp ax, 25
 jne loop_y

 inc word [time]
 jmp render

epilogue:
%if ($ - $$) > 510
  %fatal "Bootloader code exceed 512 bytes."
%endif

time dw 0
posx dw 0
posy dw 0
result dw 0

timefactor dd 0.1
ampx dd 12.0
ampy dd 6.0
centerx dd 40.0
centery dd 12.0
normx dd 80.0
normy dd 16.0
scaled dd 16.0
scalet dd 0.5
gradients dd 15.0
calccx dd 0.0
calccy dd 0.0

gradient db " .,'-^:+=xo*%#&X"

times 510 - ($ - $$) db 0 ; fill the rest of the sector with 0's
dw 0xAA55                 ; end signature
